import numpy as np
from sklearn.model_selection import train_test_split
from sklearn.linear_model import LinearRegression

# Leemos los datos de entrada
X0 = np.loadtxt( "datos10.txt" )
n,m = X0.shape

# Los datos para el modelo con un polinomio de grado 9 
X = np.zeros( (n, 9) )
print( X.shape )
X[:,8] = X0[:,0]            # x
i = 7
while i>=0 :
	X[:,i] = X[:,i+1] * X0[:,0]   # x^i
	i -= 1

# Separamos los datos para entrenamiento y prueba
X_entrena, X_prueba, y_entrena, y_prueba = train_test_split( X, X0[:,1], random_state=21 )

print( X_entrena.shape )
print( X_prueba.shape )
print( y_entrena.shape )
print( y_prueba.shape )

# Voy a guardar los datos de entrenamiento
n,m = X_entrena.shape
D = np.zeros( (n,2) )
D[:,0] = X_entrena[:,8]
D[:,1] = y_entrena
print( "D:", D.shape )
np.savetxt( "entrena.txt", D )


# Realizamos al ajuste
reg = LinearRegression()
reg.fit(X_entrena, y_entrena)
y_predichas = reg.predict(X_prueba)

v = y_prueba - y_predichas
print( v )

v = v.reshape( (-1,1) )
print( v.shape )

n,m = v.shape
print( "n=", n )

error_rms = np.sqrt( ( v.T @ v )/n ) 
#                     1xn  nx1 

print( "Error RMS =", error_rms )

print( "El modelo:" )
print( reg.coef_  )
print( reg.intercept_ )

