import numpy as np
import matplotlib.pyplot as plt

# Leemos los datos de entrada
X = np.loadtxt( "datos10.txt" )

fig, axis = plt.subplots( )

axis.scatter( X[:,0], X[:,1] )

# El modelo ajustado:
a = np.array( [ 3.99373923e-05, -4.98641586e-04,  1.69740413e-04,  1.92337925e-02,
               -7.14553350e-02,  1.16323241e-02,  1.11112982e-01,  1.43992384e-01,
                1.25731283e-01] )

a0 = 0.09156252730330763

def modelo( x ) :
	xx = x
	i = 8
	suma = a[i]*xx
	i -= 1
	while i>=0 :
		xx *= x
		suma += a[i]*xx
		i -= 1

	return suma + a0

# El modelo con un polinomio de grado 7
b = [ 0.00180132, -0.03794252,  0.29719924, -1.01390078,  1.18179111,  0.52099523, -0.93908263]
b0 = 0.09156252730293521

# El modelo con un polinomio de grado 7,
# y con regularización Ridge, alpha=0.01
c = [ 0.00045162, -0.01045432,  0.08639458, -0.28272713,  0.20125905,  0.30669621, 0.1617953 ]
c0 = 0.0918031577510807


def modelo7( x, bb, bb0 ) :
	xx = x
	i = 6
	suma = bb[i]*xx
	i -= 1
	while i>=0 :
		xx *= x
		suma += bb[i]*xx
		i -= 1

	return suma + bb0

# La grafica del modelo
# ax.plot( X[:,0], y )

D = np.loadtxt( "entrena.txt" )
print( D.shape )
print( D[:,0] )
print( D[:,1] )

axis.scatter( D[:,0], D[:,1] )

vx = np.linspace( 0, 6.5, 50 )
vy = np.zeros( (50,) )
i = 0
while i<50 :
	vy[i] = modelo( vx[i] )
	i += 1

axis.plot( vx, vy )

vy2 = np.zeros( (50,) )
i = 0
while i<50 :
	vy2[i] = modelo7( vx[i], b, b0 )
	i += 1

axis.plot( vx, vy2 )

i = 0
while i<50 :
	vy2[i] = modelo7( vx[i], c, c0 )
	i += 1
axis.plot( vx, vy2 )

plt.show( )


